package com.thesis.epr;

import java.util.Random;

import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttException;
import org.eclipse.paho.client.mqttv3.MqttMessage;

public class Server {
	
	private String[] subjects;
	private String[] predicates;
	private String[] objects;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		Server server = new Server();
		server.go();
	}
	
	public Server() {
		subjects = new String[2];
		subjects[0] = "Mike";
		subjects[1] = "Anna";
		
		predicates = new String[1];
		predicates[0] = "has_diagnosis";
		
		objects = new String[2];
		objects[0] = "diabetes";
		objects[1] = "heart_attack";
	}
	
	public void go() {
		MqttClient client;
	    try {
	      client = new MqttClient("tcp://localhost:1883", "epr");
	      while(true) {
	    	  client.connect();
		      MqttMessage message = new MqttMessage();
		      String context = "";
		      
		      Random random = new Random();
		      int num = random.nextInt(subjects.length);
		      context = subjects[num];
		      
		      num = random.nextInt(predicates.length);
		      context += " " + predicates[num];
		      
		      num = random.nextInt(objects.length);
		      context += " " + objects[num];
		      
		      message.setPayload(context.getBytes());
		      client.publish("epr", message);
		      client.disconnect();
		      try {
				  Thread.sleep(10000);
			  } catch (InterruptedException e) {
				  // TODO Auto-generated catch block
				  e.printStackTrace();
			  }
	      }
	    } catch (MqttException e) {
	      e.printStackTrace();
	    }
	}

}
