package com.thesis.patientSensor;

import java.util.Random;

import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttException;
import org.eclipse.paho.client.mqttv3.MqttMessage;

public class Server {
	
	private String[] subjects;
	private String[] predicates;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		Server server = new Server();
		server.go();
	}
	
	public Server() {
		subjects = new String[2];
		subjects[0] = "Mike";
		subjects[1] = "Anna";
		
		predicates = new String[17];
		predicates[0] = "has_blood_pressure 80";
		predicates[1] = "has_blood_pressure 100";
		predicates[2] = "has_blood_pressure 110";
		predicates[3] = "has_blood_pressure 150";
		predicates[4] = "has_blood_pressure 180";
		predicates[5] = "has_body_temperature 36";
		predicates[6] = "has_body_temperature 36.5";
		predicates[7] = "has_body_temperature 37";
		predicates[8] = "has_body_temperature 38";
		predicates[9] = "has_body_temperature 38.5";
		predicates[10] = "has_body_temperature 40";
		predicates[11] = "has_body_temperature 40.7";
		predicates[12] = "has_heart_beat 67";
		predicates[13] = "has_heart_beat 89";
		predicates[14] = "has_heart_beat 92";
		predicates[15] = "has_heart_beat 119";
		predicates[16] = "has_heart_beat 100";
	}
	
	public void go() {
		MqttClient client;
	    try {
	      client = new MqttClient("tcp://localhost:1883", "patientSensor");
	      while(true) {
	    	  client.connect();
		      MqttMessage message = new MqttMessage();
		      String context = "";
		      
		      Random random = new Random();
		      int num = random.nextInt(subjects.length);
		      context = subjects[num];
		      
		      num = random.nextInt(predicates.length);
		      context += " " + predicates[num];
		      
		      message.setPayload(context.getBytes());
		      client.publish("patientSensor", message);
		      client.disconnect();
		      try {
				  Thread.sleep(10000);
			  } catch (InterruptedException e) {
				  // TODO Auto-generated catch block
				  e.printStackTrace();
			  }
	      }
	    } catch (MqttException e) {
	      e.printStackTrace();
	    }
	}

}
