package con.thesis.testUrgency;

import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;

public class Request {
	public static int URGENCY = 1;
	public static int FEEDBACK = 2;
	
	private int type;
	private String callId;
	private String urgency;
	private String patient;
	
	public Request(int type) {
		this.type = type;
	}

	public String getCallId() {
		return callId;
	}

	public void setCallId(String callId) {
		this.callId = callId;
	}

	public String getUrgency() {
		return urgency;
	}

	public void setUrgency(String urgency) {
		this.urgency = urgency;
	}

	public String getPatient() {
		return patient;
	}

	public void setPatient(String patient) {
		this.patient = patient;
	}
	
	public String toXML() {
		String xml = null;
		try {
			Document document = DocumentHelper.createDocument();
	        Element requestElement = document.addElement("request");
	        
	        Element callIdElement = requestElement.addElement("callId");
	        callIdElement.setText(callId);
	        
	        if(type == this.URGENCY) {
	        	Element patientElement = requestElement.addElement("patient");
	        	patientElement.setText(patient);
	        } else {
	        	Element urgencyElement = requestElement.addElement("urgency");
	        	urgencyElement.setText(urgency);
	        }
	        xml = requestElement.asXML();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return xml;
	}
}
