package con.thesis.testUrgency;

import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;

public class Response {
	private String status;
	private String message;
	private String urgency;
	
	public Response(String rawMessage) {
		if(rawMessage == null || rawMessage.isEmpty()) {
			return;
		}
		
		try {
			Document document = DocumentHelper.parseText(rawMessage);
			Element responseElement = document.getRootElement();
			
			status = responseElement.attributeValue("status");
			if(status == null) {
				return;
			}
			if(status.equals("200")) {
				urgency = responseElement.elementText("urgency");
			} else {
				message = responseElement.elementText("message");
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public String getStatus() {
		return status;
	}
	
	public void setStatus(String status) {
		this.status = status;
	}
	
	public String getMessage() {
		return message;
	}
	
	public void setMessage(String message) {
		this.message = message;
	}
	
	public String getUrgency() {
		return urgency;
	}
	
	public void setUrgency(String urgency) {
		this.urgency = urgency;
	}
	
	
}
